%bcond_with perl_YAML_LibYAML_enables_optional_test

Summary:        Perl YAML Serialization using XS and libyaml
Name:           perl-YAML-LibYAML
Version:        0.86
Release:        5%{?dist}
License:        GPL-1.0-or-later OR Artistic-1.0-Perl
URL:            https://metacpan.org/release/YAML-LibYAML
Source0:        https://cpan.metacpan.org/modules/by-module/YAML/YAML-LibYAML-%{version}.tar.gz
Patch3000:      YAML-LibYAML-0.79-Unbundled-libyaml.patch

BuildRequires: perl(utf8)
BuildRequires: perl(Test::More) >= 0.90 perl(Tie::Array) perl(Tie::Hash)
BuildRequires: perl(FindBin) perl(IO::File) perl(IO::Pipe) perl(lib) perl(Test::Builder)
BuildRequires: perl(Devel::Peek) perl(Encode) perl(File::Find) perl(File::Path) perl(Filter::Util::Call)
BuildRequires: perl(XSLoader) perl(B) perl(blib) perl(Carp) perl(Data::Dumper)
BuildRequires: perl(constant) perl(Exporter) perl(Scalar::Util) perl(strict) perl(warnings)
BuildRequires: sed perl(B::Deparse) perl(base) libyaml-devel >= 0.2.4
BuildRequires: perl-devel perl-generators perl-interpreter perl(Config) perl(ExtUtils::MakeMaker) >= 6.76
BuildRequires: coreutils findutils gcc make libyaml >= 0.2.4

%if %{with perl_YAML_LibYAML_enables_optional_test}
BuildRequires:  perl(Path::Class)
%endif

Requires:       perl(B::Deparse)
Requires:       libyaml >= 0.2.4

%{?perl_default_filter}
%global __provides_exclude_from %{?__provides_exclude_from:%__provides_exclude_from|}^%{_libexecdir}
%global __requires_exclude %{?__requires_exclude:%__requires_exclude|}^perl\\(TestYAML.*\\)

%description
Kirill Siminov's "libyaml" is arguably the best YAML implementation. The C
library is written precisely to the YAML 1.1 specification. It was originally
bound to Python and was later bound to Ruby.

%if %{with perl_YAML_LibYAML_enables_optional_test}
%package tests
Summary:        Tests for %{name}
Requires:       %{name} = %{version}-%{release}
Requires:       perl-Test-Harness

%description tests
Tests from %{name}. Execute them
with "%{_libexecdir}/%{name}/test".
%endif

%prep
%autosetup -p1 -n YAML-LibYAML-%{version}
for file in api.c dumper.c emitter.c loader.c parser.c reader.c scanner.c \
    writer.c yaml.h yaml_private.h; do
    rm LibYAML/$file
    sed -i -e "/^LibYAML\/$file/d" MANIFEST
done
for F in t/*.t; do
    perl -i -MConfig -ple 'print $Config{startperl} if $. == 1 && !s{\A#!.*perl\b}{$Config{startperl}}' "$F"
    chmod +x "$F"
done

%build
perl Makefile.PL INSTALLDIRS=vendor OPTIMIZE="%{optflags}" NO_PACKLIST=1 NO_PERLLOCAL=1
%{make_build}

%install
%{make_install}
find %{buildroot} -type f -name '*.bs' -empty -delete
%{_fixperms} -c %{buildroot}

mkdir -p %{buildroot}%{_libexecdir}/%{name}
cp -a t %{buildroot}%{_libexecdir}/%{name}
rm %{buildroot}%{_libexecdir}/%{name}/t/000-require-modules.t
rm %{buildroot}%{_libexecdir}/%{name}/t/author-pod-syntax.t
perl -i -pe 's{^use blib;}{#use blib;}' %{buildroot}%{_libexecdir}/%{name}/t/TestYAML.pm
perl -i -pe 's{^use_blib: 1}{use_blib: 0}' %{buildroot}%{_libexecdir}/%{name}/t/yaml_tests.yaml

%if %{without perl_YAML_LibYAML_enables_optional_test}
rm -rf %{buildroot}%{_libexecdir}/%{name}
%endif

%check
export HARNESS_OPTIONS=j%{_smp_build_ncpus}
make test

%files
%license LICENSE
%doc Changes CONTRIBUTING README
%{perl_vendorarch}/auto/YAML/
%{perl_vendorarch}/YAML/
%{_mandir}/man3/YAML::LibYAML.3*
%{_mandir}/man3/YAML::XS.3*
%{_mandir}/man3/YAML::XS::LibYAML.3*

%if %{with perl_YAML_LibYAML_enables_optional_test}
%files tests
%{_libexecdir}/%{name}
%endif

%changelog
* Thu Sep 26 2024 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 0.86-5
- Rebuilt for clarifying the packages requirement in BaseOS and AppStream

* Fri Aug 16 2024 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 0.86-4
- Rebuilt for loongarch release

* Fri Sep 08 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 0.86-3
- Rebuilt for OpenCloudOS Stream 23.09

* Fri Apr 28 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 0.86-2
- Rebuilt for OpenCloudOS Stream 23.05

* Tue Apr 04 2023 cunshunxia <cunshunxia@tencent.com> - 0.86-1
- initial build
